/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
 The code simply displays a way of communicating with the a 24 bit ADC over SPI.
 It only runs once. The code does the following:
 
 1. Writes data first to a register as required.
 2. Starts a transfer by sending a reading command over SPI.
 3. Sends dummy data to receive the data from the ADC.
 
 *=========================================
*/
#include <device.h>
uint32 Readvalue[4];
uint8 dummyvar;
uint8 i;

void main()
{
    /* Place your initialization/startup code here (e.g. MyInst_Start()) */
    
    CyGlobalIntEnable; /* Uncomment this line to enable global interrupts. */
    SPIM_Start();

    SPIM_ClearTxBuffer();
    SPIM_ClearRxBuffer();

    // Sending first write to the b1100000 register.
    SS_Write(0);                //Slave Select Low
    SPIM_WriteTxData(0x60);     //
    SPIM_WriteTxData(0x34);     //Address and value of the register sent.
    while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE)); // Wait till the transfer is over.
    SS_Write(1);                //Slave Select High

    // For reading 3 bytes of data and sending a command byte.

    SS_Write(0);                
    CyDelayUs(1);               //Delay given to let the ADC output pin stabilize
                            
    SPIM_WriteTxData(0xF0);     //Commmand to read the register values.
    while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE));
    
    SPIM_ClearRxBuffer();       //Read buffer will have two + one bytes of data, so clear the RX FIFO before reading 24 bits of data as you need.
    
    for(i=0;i<4;i++)
    {
    
        SPIM_WriteTxData(0x00);     
        SPIM_WriteTxData(0x00);     
        SPIM_WriteTxData(0x00); //Queue 24 bits of dummy data
        
        while(!(SPIM_ReadTxStatus() & SPIM_STS_SPI_DONE)); // Wait till the three bytes are sent. Or check the RXStatus if some data has been received, but that doesn't tell if all 3 bytes have been received. Thus check when the Tx FIFO is sent completly.
        
        dummyvar = SPIM_ReadRxData();
        Readvalue[i]|=dummyvar;
        Readvalue[i]<<=8;
        dummyvar = SPIM_ReadRxData();
        Readvalue[i]|=dummyvar;
        Readvalue[i]<<=8;
        dummyvar = SPIM_ReadRxData();
        Readvalue[i]|=dummyvar;
       
    }
    CyDelayUs(1);
    SS_Write(1);
    CyDelayUs(1);
    
    for(;;)
    {
        /* Place your application code here. */
    }
}

/* [] END OF FILE */
